#ifndef __CANVAS_H__
#define __CANVS_H__

#include "glutWindow.h"
#include "particles.h"
#include "lines.h"

// The Canvas is used to draw on
// and to accept keyboard inputs
class Canvas : public GlutWindow {

   public: 
      // Constructor takes width and height of drawing window
      Canvas(int width=640, int height=480);
      ~Canvas();

      // Inherited from GlutWindow
      virtual void CallBackDisplayFunc();
      virtual void CallBackKeyboardFunc(unsigned char key, int x, int y);
      virtual void CallBackReshapeFunc(int w, int h);

      // We only implement mouse clicks
      virtual void CallBackMouseFunc(int button, int state, int x, int y);

   private:

      // Randomly sample some particles
      void createParticles();

      // Create some lines used for illustrating the transparency criterion
      void createLines();

   private:

      int _width; // width of the drawing canvas
      int _height; // height of the drawing canvas

      int _picked_particle; // keep track of which particle was picked for drawing its shape function
      bool _draw_shape_functions; // if true, draw the shape function, if false, draw the weight function


      Particles * particles;
      Lines * lines;
};

#endif
