#ifndef __LINES_H__
#define __LINES_H__

#include <vector>
using namespace std;

#include "lineSegment.h"

/**
 * Collection of line segments
 */
class Lines {

   public:
      Lines() {}

      // We are responsible for deleting lines
      ~Lines() { 
         for (int i=0; i<_lines.size(); i++) {
            delete _lines[i];
         }
         _lines.clear();
      }

      // Add a line segment to the collection
      void addLine(LineSegment * segment) { _lines.push_back(segment); }

      // Number of lines in this collection
      int nbLines() const { return _lines.size(); }

      // Get the line at the given index.
      // Index must be in the valid range.
      LineSegment * getLine(int index) { return _lines[index]; }

   private:
      vector<LineSegment*> _lines;

};

#endif
