#ifndef __MATRIX3X3F_H__
#define __MATRIX3X3F_H__

#include "vector3f.h"

class MyMatrix;

class matrix3x3f {
public:

	float m[9];

   matrix3x3f()  { identity(); }

   matrix3x3f(float * mm) {
      for (int i=0; i<9; i++) {
         m[i]  = mm[i];
      }
   }

   matrix3x3f(MyMatrix *mm);

   void zero() {
      for (int i=0; i<9; i++) {
         m[i] = 0;
      }
   }

 	matrix3x3f(  float m0, float m3, float m6,
               float m1, float m4, float m7,
               float m2, float m5, float m8);

   void add(   float m0, float m3, float m6,
               float m1, float m4, float m7,
               float m2, float m5, float m8);

	void identity(void);
   void transform( vector3f *vec ) const;
   float getInfNorm() const;
   matrix3x3f transpose() const;

   float& operator() (int i, int j) {
      return m[i+j*3];
   }
   const float operator() (int i, int j) const {
      return m[i+j*3];
   }

   void print() const;
  
   float getDeterminant() const;

	matrix3x3f operator + (const matrix3x3f &other);
	matrix3x3f operator - (const matrix3x3f &other);
	matrix3x3f operator * (const matrix3x3f &other) const;
	matrix3x3f operator * (const float scalar);
};

#endif

